! package main 
!     for 2-D thermal convection in a square box. 
!
! 99/05/04  S. Takehiro
!
program dbldifbox_init

  use dimension
  use coordinates

  use math
  use variables
  use diffuse_boundary
  use output_netcdf

  implicit none
  character(len=15)  :: file='ddbox_init.data'

!============================== ɸ ==============================
  call coordinates_init

  allocate ( temp(nx,nz), C(nx,nz) )
  allocate ( zeta(nx,nz), psi(nx,nz) )

!================================  ================================

      psi = 0.0

      zeta = laplace(psi)
      call diffuse_boundary_zeta(zeta,psi) 

      !temp =0.0
      temp = 1-zz
      !temp = zz
      temp(nx/2,nz/4) = temp(nx/2,nz/4) + 0.01
      
      !C = 0.0
      !C = 1.0-zz
      !C(nx/4,nz/4) = C(nx/4,nz/4) + 0.01
      !C(nx/2,2) = C(nx/2,2) + 0.01
      !C = exp( - ( (xx-0.5)**2+(zz-0.5)**2)/0.1**2 ) 
      !C(:nx/10,:) = 0.0 ; C(9*nx/10:,:) = 0.0
      !C(:,:nz/10) = 0.0 ; C(:,9*nz/10:) = 0.0


!=================================  =================================
  call output_netcdf_init( file )
  call output_netcdf_data( file )

  stop

end program dbldifbox_init
